Bug 1410481 (CVE-2017-2582)

Summary: CVE-2017-2582 picketlink, keycloak: SAML request parser replaces special strings with system properties
Product: [Other] Security Response Reporter: Adam Mariš <amaris>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: NEW --- QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: aileenc, alazarot, anstephe, asoldano, avibelli, bbaranow, bdawidow, bmaxwell, brian.stansberry, cdewolf, chazlett, csutherl, dandread, darran.lofthouse, dffrench, dimitris, dosoudil, drieden, drusso, etirelli, fgavrilo, fnasser, gsterlin, hmlnarik, ibek, iweiss, jason.greene, java-sig-commits, jawilson, jbalunas, jclere, jcoleman, jkurik, jmadigan, jondruse, jpallich, jperkins, jshepherd, kpiwko, krathod, kverlaen, kwills, lef, lgao, lgriffin, loleary, lpetrovi, mbaluch, miburman, msochure, msvehla, mweiler, mwinkler, myarboro, ngough, nwallace, paradhya, pbraun, pdrozd, pgier, pmackay, ppalaga, psakar, pslavice, psotirop, puntogil, pwright, rguimara, rnetuka, rrajasek, rstancel, rsvoboda, rsynek, rzhang, sdaley, security-response-team, smaestri, spinder, sthorger, theute, tkirby, tom.jenkinson, trepel, ttarrant, twalsh, vtunka
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: impact=moderate,public=20170926,reported=20170105,source=redhat,cvss3=6.5/CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N,cwe=CWE-201,bpms-6/picketlink-idm-core=notaffected,brms-6/picketlink-idm-core=notaffected,jdg-6/picketlink-idm-impl=notaffected,jdg-6/picketlink-impl=notaffected,eap-6/picketlink-idm-impl=new,eap-6/picketlink-impl=affected,eap-7/picketlink-idm-impl=notaffected,eap-7/picketlink, keycloak=affected,jon-3/picketlink-idm-impl=notaffected,jon-3/picketlink-impl=notaffected,jpp-6/picketlink-idm-impl=wontfix,jpp-6/picketlink-impl=wontfix,rhsso-7/picketlink-idm-impl=notaffected,rhsso-7/picketlink-impl=notaffected,rhsso-7/keycloak-saml-core=notaffected,rhsso-7/keycloak-core=notaffected,rhmap-4/keycloak-core=notaffected,fedora-all/picketlink=affected,fuse-6/switchyard=notaffected
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
It was found that while parsing the SAML messages the StaxParserUtil class of Picketlink replaces special strings for obtaining attribute values with system property. This could allow an attacker to determine values of system properties at the attacked system by formatting the SAML request ID field to be the chosen system property which could be obtained in the "InResponseTo" field in the response.
Story Points: ---
Clone Of: Environment:
Last Closed: Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 1710644, 1414137, 1414138    
Bug Blocks: 1410492, 1493931, 1510311    

Description Adam Mariš 2017-01-05 15:31:11 UTC
It was found that Picketlink implementation replaces special strings for obtaining attribute values with system property values in SAML messages while parsing. An attacker can misuse this to determine values of system properties at the attacked system by formatting the SAML request ID field to the chosen system property name of his liking, obtaining the property value in "InResponseTo" field in the response.

Upstream bug (for Keycloak):

https://issues.jboss.org/browse/KEYCLOAK-4160

Comment 2 Adam Mariš 2017-01-10 11:44:35 UTC
Acknowledgments:

Name: Hynek Mlnarik (Red Hat)

Comment 5 Jason Shepherd 2017-09-18 01:50:47 UTC
JON-3 is not affected by this issue because it's not supported as a SSO Identity Provider.

Comment 6 errata-xmlrpc 2017-09-26 17:58:22 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.0.8

Via RHSA-2017:2810 https://access.redhat.com/errata/RHSA-2017:2810

Comment 7 errata-xmlrpc 2017-09-26 18:41:05 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.0 for RHEL 7

Via RHSA-2017:2808 https://access.redhat.com/errata/RHSA-2017:2808

Comment 8 errata-xmlrpc 2017-09-26 18:53:21 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.0 for RHEL 6

Via RHSA-2017:2809 https://access.redhat.com/errata/RHSA-2017:2809

Comment 9 errata-xmlrpc 2017-09-26 19:14:39 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.0 for RHEL 7
  Red Hat JBoss Enterprise Application Platform 7.0 for RHEL 6

Via RHSA-2017:2811 https://access.redhat.com/errata/RHSA-2017:2811

Comment 11 errata-xmlrpc 2017-11-14 20:37:20 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 6.4 for RHEL 7

Via RHSA-2017:3218 https://access.redhat.com/errata/RHSA-2017:3218

Comment 12 errata-xmlrpc 2017-11-14 20:38:03 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 6.4 for RHEL 6

Via RHSA-2017:3217 https://access.redhat.com/errata/RHSA-2017:3217

Comment 13 errata-xmlrpc 2017-11-14 20:38:26 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 6.4 for RHEL 5

Via RHSA-2017:3216 https://access.redhat.com/errata/RHSA-2017:3216

Comment 14 errata-xmlrpc 2017-11-14 20:39:49 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform

Via RHSA-2017:3220 https://access.redhat.com/errata/RHSA-2017:3220

Comment 15 errata-xmlrpc 2017-11-14 20:51:31 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 6.4 for RHEL 6

Via RHSA-2017:3219 https://access.redhat.com/errata/RHSA-2017:3219

Comment 20 Jason Shepherd 2018-01-17 04:39:00 UTC
RHMAP services, UPS and Millicore don't use SAML features of embedded Keycloak.

Comment 21 errata-xmlrpc 2018-09-24 21:46:28 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform

Via RHSA-2018:2740 https://access.redhat.com/errata/RHSA-2018:2740

Comment 22 errata-xmlrpc 2018-09-24 22:04:20 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 6.4 for RHEL 7

Via RHSA-2018:2741 https://access.redhat.com/errata/RHSA-2018:2741

Comment 23 errata-xmlrpc 2018-09-24 22:08:12 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 6.4 for RHEL 5

Via RHSA-2018:2742 https://access.redhat.com/errata/RHSA-2018:2742

Comment 24 errata-xmlrpc 2018-09-24 22:09:29 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 6.4 for RHEL 6

Via RHSA-2018:2743 https://access.redhat.com/errata/RHSA-2018:2743

Comment 25 errata-xmlrpc 2019-01-22 16:30:42 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform

Via RHSA-2019:0139 https://access.redhat.com/errata/RHSA-2019:0139

Comment 26 errata-xmlrpc 2019-01-22 16:36:38 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 7

Via RHSA-2019:0137 https://access.redhat.com/errata/RHSA-2019:0137

Comment 27 errata-xmlrpc 2019-01-22 16:54:52 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 6

Via RHSA-2019:0136 https://access.redhat.com/errata/RHSA-2019:0136

Comment 28 Joshua Padman 2019-05-15 22:59:02 UTC
This vulnerability is out of security support scope for the following product:
 * Red Hat Enterprise Application Platform 6

Please refer to https://access.redhat.com/support/policy/updates/jboss_notes for more details.

Comment 29 Joshua Padman 2019-05-15 23:40:30 UTC
Created picketlink tracking bugs for this issue:

Affects: fedora-all [bug 1710644]